///<reference path="../.d.ts"/>
"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    __.prototype = b.prototype;
    d.prototype = new __();
};
var BuildCommandBase = (function () {
    function BuildCommandBase($platformService) {
        this.$platformService = $platformService;
    }
    BuildCommandBase.prototype.executeCore = function (args, buildConfig) {
        return this.$platformService.buildPlatform(args[0], buildConfig);
    };
    return BuildCommandBase;
})();
exports.BuildCommandBase = BuildCommandBase;
var BuildIosCommand = (function (_super) {
    __extends(BuildIosCommand, _super);
    function BuildIosCommand($platformService, $platformsData) {
        _super.call(this, $platformService);
        this.$platformsData = $platformsData;
        this.allowedParameters = [];
    }
    BuildIosCommand.prototype.execute = function (args) {
        return this.executeCore([this.$platformsData.availablePlatforms.iOS]);
    };
    return BuildIosCommand;
})(BuildCommandBase);
exports.BuildIosCommand = BuildIosCommand;
$injector.registerCommand("build|ios", BuildIosCommand);
var BuildAndroidCommand = (function (_super) {
    __extends(BuildAndroidCommand, _super);
    function BuildAndroidCommand($platformService, $platformsData, $options, $errors) {
        _super.call(this, $platformService);
        this.$platformsData = $platformsData;
        this.$options = $options;
        this.$errors = $errors;
        this.allowedParameters = [];
    }
    BuildAndroidCommand.prototype.execute = function (args) {
        var config = this.$options.staticBindings ? { runSbGenerator: true } : undefined;
        return this.executeCore([this.$platformsData.availablePlatforms.Android], config);
    };
    BuildAndroidCommand.prototype.canExecute = function (args) {
        var _this = this;
        return (function () {
            if (_this.$options.release && (!_this.$options.keyStorePath || !_this.$options.keyStorePassword || !_this.$options.keyStoreAlias || !_this.$options.keyStoreAliasPassword)) {
                _this.$errors.fail("When producing a release build, you need to specify all --key-store-* options.");
            }
            return args.length === 0;
        }).future()();
    };
    return BuildAndroidCommand;
})(BuildCommandBase);
exports.BuildAndroidCommand = BuildAndroidCommand;
$injector.registerCommand("build|android", BuildAndroidCommand);
