///<reference path="../.d.ts"/>
"use strict";
var InstallCommand = (function () {
    function InstallCommand($platformsData, $platformService, $projectData, $projectDataService, $pluginsService, $logger) {
        this.$platformsData = $platformsData;
        this.$platformService = $platformService;
        this.$projectData = $projectData;
        this.$projectDataService = $projectDataService;
        this.$pluginsService = $pluginsService;
        this.$logger = $logger;
        this.enableHooks = false;
        this.allowedParameters = [];
    }
    InstallCommand.prototype.execute = function (args) {
        var _this = this;
        return (function () {
            var error = "";
            _this.$pluginsService.ensureAllDependenciesAreInstalled().wait();
            _this.$projectDataService.initialize(_this.$projectData.projectDir);
            _.each(_this.$platformsData.platformsNames, function (platform) {
                var platformData = _this.$platformsData.getPlatformData(platform);
                var frameworkPackageData = _this.$projectDataService.getValue(platformData.frameworkPackageName).wait();
                if (frameworkPackageData && frameworkPackageData.version) {
                    try {
                        _this.$platformService.addPlatforms([(platform + "@" + frameworkPackageData.version)]).wait();
                    }
                    catch (err) {
                        error += err;
                    }
                }
            });
            if (error) {
                _this.$logger.error(error);
            }
        }).future()();
    };
    return InstallCommand;
})();
exports.InstallCommand = InstallCommand;
$injector.registerCommand("install", InstallCommand);
