///<reference path="../../.d.ts"/>
"use strict";
var UninstallApplicationCommand = (function () {
    function UninstallApplicationCommand($devicesServices, $stringParameter, $options) {
        this.$devicesServices = $devicesServices;
        this.$stringParameter = $stringParameter;
        this.$options = $options;
        this.allowedParameters = [this.$stringParameter];
    }
    UninstallApplicationCommand.prototype.execute = function (args) {
        var _this = this;
        return (function () {
            _this.$devicesServices.initialize({ deviceId: _this.$options.device, skipInferPlatform: true }).wait();
            var action = function (device) {
                return (function () { return device.applicationManager.uninstallApplication(args[0]).wait(); }).future()();
            };
            _this.$devicesServices.execute(action).wait();
        }).future()();
    };
    return UninstallApplicationCommand;
})();
exports.UninstallApplicationCommand = UninstallApplicationCommand;
$injector.registerCommand("device|uninstall", UninstallApplicationCommand);
